/*
  File autogenerated by gengetopt version 2.15
  generated with the following command:
  gengetopt --input=histogram_cmd.ggo --file-name=histogram_cmd --unamed-opts 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "histogram_cmd.h"

static
void clear_given (struct gengetopt_args_info *args_info);
static
void clear_args (struct gengetopt_args_info *args_info);

static int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error);

static int
cmdline_parser_required2 (struct gengetopt_args_info *args_info, const char *prog_name, const char *additional_error);

static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gengetopt_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->out_given = 0 ;
  args_info->bins_given = 0 ;
  args_info->min_given = 0 ;
  args_info->max_given = 0 ;
}

static
void clear_args (struct gengetopt_args_info *args_info)
{
  args_info->out_arg = NULL;
  args_info->out_orig = NULL;
  args_info->bins_arg = 10;
  args_info->bins_orig = NULL;
  args_info->min_orig = NULL;
  args_info->max_orig = NULL;
  
}

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\n%s\n", "Bin data for plotting histograms");
  printf("\nUsage: histogram [OPTIONS]... [FILES]...\n\n");
  printf("%s\n","  -h, --help          Print help and exit");
  printf("%s\n","  -V, --version       Print version and exit");
  printf("%s\n","  -o, --out=filename  Write the binned counts to this file");
  printf("%s\n","  -b, --bins=INT      Number of bins to use  (default=`10')");
  printf("%s\n","  -m, --min=FLOAT     Minimum value to start binning");
  printf("%s\n","  -M, --max=FLOAT     Maximum value to end binning");
  
}

void
cmdline_parser_init (struct gengetopt_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);

  args_info->inputs = NULL;
  args_info->inputs_num = 0;
}

static void
cmdline_parser_release (struct gengetopt_args_info *args_info)
{
  
  unsigned int i;
  if (args_info->out_arg)
    {
      free (args_info->out_arg); /* free previous argument */
      args_info->out_arg = 0;
    }
  if (args_info->out_orig)
    {
      free (args_info->out_orig); /* free previous argument */
      args_info->out_orig = 0;
    }
  if (args_info->bins_orig)
    {
      free (args_info->bins_orig); /* free previous argument */
      args_info->bins_orig = 0;
    }
  if (args_info->min_orig)
    {
      free (args_info->min_orig); /* free previous argument */
      args_info->min_orig = 0;
    }
  if (args_info->max_orig)
    {
      free (args_info->max_orig); /* free previous argument */
      args_info->max_orig = 0;
    }
  
  for (i = 0; i < args_info->inputs_num; ++i)
    free (args_info->inputs [i]);
  
  if (args_info->inputs_num)
    free (args_info->inputs);
  
  clear_given (args_info);
}

int
cmdline_parser_file_save(const char *filename, struct gengetopt_args_info *args_info)
{
  FILE *outfile;
  int i = 0;

  outfile = fopen(filename, "w");

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot open file for writing: %s\n", CMDLINE_PARSER_PACKAGE, filename);
      return EXIT_FAILURE;
    }

  if (args_info->help_given) {
    fprintf(outfile, "%s\n", "help");
  }
  if (args_info->version_given) {
    fprintf(outfile, "%s\n", "version");
  }
  if (args_info->out_given) {
    if (args_info->out_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "out", args_info->out_orig);
    } else {
      fprintf(outfile, "%s\n", "out");
    }
  }
  if (args_info->bins_given) {
    if (args_info->bins_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "bins", args_info->bins_orig);
    } else {
      fprintf(outfile, "%s\n", "bins");
    }
  }
  if (args_info->min_given) {
    if (args_info->min_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "min", args_info->min_orig);
    } else {
      fprintf(outfile, "%s\n", "min");
    }
  }
  if (args_info->max_given) {
    if (args_info->max_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "max", args_info->max_orig);
    } else {
      fprintf(outfile, "%s\n", "max");
    }
  }
  
  fclose (outfile);

  i = EXIT_SUCCESS;
  return i;
}

void
cmdline_parser_free (struct gengetopt_args_info *args_info)
{
  cmdline_parser_release (args_info);
}


/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  return cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  int result;

  result = cmdline_parser_internal (argc, argv, args_info, override, initialize, check_required, NULL);

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_required (struct gengetopt_args_info *args_info, const char *prog_name)
{
  int result = EXIT_SUCCESS;

  if (cmdline_parser_required2(args_info, prog_name, NULL) > 0)
    result = EXIT_FAILURE;

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_required2 (struct gengetopt_args_info *args_info, const char *prog_name, const char *additional_error)
{
  int error = 0;

  if (! args_info->out_given)
    {
      fprintf (stderr, "%s: '--out' ('-o') option required%s\n", prog_name, (additional_error ? additional_error : ""));
      error = 1;
    }

  return error;
}

int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */

  int error = 0;
  struct gengetopt_args_info local_args_info;

  if (initialize)
    cmdline_parser_init (args_info);

  cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "out",	1, NULL, 'o' },
        { "bins",	1, NULL, 'b' },
        { "min",	1, NULL, 'm' },
        { "max",	1, NULL, 'M' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVo:b:m:M:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          cmdline_parser_print_help ();
          cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          cmdline_parser_print_version ();
          cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'o':	/* Write the binned counts to this file.  */
          if (local_args_info.out_given)
            {
              fprintf (stderr, "%s: `--out' (`-o') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->out_given && ! override)
            continue;
          local_args_info.out_given = 1;
          args_info->out_given = 1;
          if (args_info->out_arg)
            free (args_info->out_arg); /* free previous string */
          args_info->out_arg = gengetopt_strdup (optarg);
          if (args_info->out_orig)
            free (args_info->out_orig); /* free previous string */
          args_info->out_orig = gengetopt_strdup (optarg);
          break;

        case 'b':	/* Number of bins to use.  */
          if (local_args_info.bins_given)
            {
              fprintf (stderr, "%s: `--bins' (`-b') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->bins_given && ! override)
            continue;
          local_args_info.bins_given = 1;
          args_info->bins_given = 1;
          args_info->bins_arg = strtol (optarg, &stop_char, 0);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->bins_orig)
            free (args_info->bins_orig); /* free previous string */
          args_info->bins_orig = gengetopt_strdup (optarg);
          break;

        case 'm':	/* Minimum value to start binning.  */
          if (local_args_info.min_given)
            {
              fprintf (stderr, "%s: `--min' (`-m') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->min_given && ! override)
            continue;
          local_args_info.min_given = 1;
          args_info->min_given = 1;
          args_info->min_arg = (float)strtod (optarg, &stop_char);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->min_orig)
            free (args_info->min_orig); /* free previous string */
          args_info->min_orig = gengetopt_strdup (optarg);
          break;

        case 'M':	/* Maximum value to end binning.  */
          if (local_args_info.max_given)
            {
              fprintf (stderr, "%s: `--max' (`-M') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->max_given && ! override)
            continue;
          local_args_info.max_given = 1;
          args_info->max_given = 1;
          args_info->max_arg = (float)strtod (optarg, &stop_char);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->max_orig)
            free (args_info->max_orig); /* free previous string */
          args_info->max_orig = gengetopt_strdup (optarg);
          break;


        case 0:	/* Long option with no short option */
        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */



  if (check_required)
    {
      error += cmdline_parser_required2 (args_info, argv[0], additional_error);
    }

  cmdline_parser_release (&local_args_info);

  if ( error )
    return (EXIT_FAILURE);

  if (optind < argc)
    {
      int i = 0 ;

      args_info->inputs_num = argc - optind ;
      args_info->inputs =
        (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        args_info->inputs[ i++ ] = gengetopt_strdup (argv[optind++]) ;
    }

  return 0;

failure:
  
  cmdline_parser_release (&local_args_info);
  return (EXIT_FAILURE);
}
