/*
  File autogenerated by gengetopt version 2.15
  generated with the following command:
  gengetopt --input=vol2vol_cmd.ggo --file-name=vol2vol_cmd --unamed-opts 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "vol2vol_cmd.h"

static
void clear_given (struct gengetopt_args_info *args_info);
static
void clear_args (struct gengetopt_args_info *args_info);

static int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error);

static int
cmdline_parser_required2 (struct gengetopt_args_info *args_info, const char *prog_name, const char *additional_error);

static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gengetopt_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->verbosity_given = 0 ;
  args_info->out_given = 0 ;
  args_info->pack_given = 0 ;
  args_info->bpv_given = 0 ;
  args_info->xscale_given = 0 ;
  args_info->yscale_given = 0 ;
  args_info->zscale_given = 0 ;
}

static
void clear_args (struct gengetopt_args_info *args_info)
{
  args_info->verbosity_arg = 0;
  args_info->verbosity_orig = NULL;
  args_info->out_arg = NULL;
  args_info->out_orig = NULL;
  args_info->pack_arg = 1;
  args_info->pack_orig = NULL;
  args_info->bpv_arg = 8;
  args_info->bpv_orig = NULL;
  args_info->xscale_arg = 1.0;
  args_info->xscale_orig = NULL;
  args_info->yscale_arg = 1.0;
  args_info->yscale_orig = NULL;
  args_info->zscale_arg = 1.0;
  args_info->zscale_orig = NULL;
  
}

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\n%s\n", "Change volume files from one type to another (e.g. 16 bit -> 8 bit)");
  printf("\nUsage: vol2vol [OPTIONS]... [FILES]...\n\n");
  printf("%s\n","  -h, --help           Print help and exit");
  printf("%s\n","  -V, --version        Print version and exit");
  printf("%s\n","  -v, --verbosity=INT  Set the verbosity level (0=quiet 10=verbose \n                         20=bombastic)  (default=`0')");
  printf("%s\n","  -o, --out=filename   Output file name");
  printf("%s\n","  -p, --pack=INT       How to scale/fit counts into voxels.\n                          0=PACK_SCALE, 1=PACK_CLIP, 2=PACK_WRAP  (default=`1')");
  printf("%s\n","  -b, --bpv=INT        Bits per voxel.  This is an unsigned data type.\n                         Can be 8, 16, or 32.  (default=`8')");
  printf("%s\n","  -j, --xscale=FLOAT   Scale the voxels.  (default=`1.0')");
  printf("%s\n","  -k, --yscale=FLOAT   Scale the voxels.  (default=`1.0')");
  printf("%s\n","  -l, --zscale=FLOAT   Scale the voxels.  (default=`1.0')");
  
}

void
cmdline_parser_init (struct gengetopt_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);

  args_info->inputs = NULL;
  args_info->inputs_num = 0;
}

static void
cmdline_parser_release (struct gengetopt_args_info *args_info)
{
  
  unsigned int i;
  if (args_info->verbosity_orig)
    {
      free (args_info->verbosity_orig); /* free previous argument */
      args_info->verbosity_orig = 0;
    }
  if (args_info->out_arg)
    {
      free (args_info->out_arg); /* free previous argument */
      args_info->out_arg = 0;
    }
  if (args_info->out_orig)
    {
      free (args_info->out_orig); /* free previous argument */
      args_info->out_orig = 0;
    }
  if (args_info->pack_orig)
    {
      free (args_info->pack_orig); /* free previous argument */
      args_info->pack_orig = 0;
    }
  if (args_info->bpv_orig)
    {
      free (args_info->bpv_orig); /* free previous argument */
      args_info->bpv_orig = 0;
    }
  if (args_info->xscale_orig)
    {
      free (args_info->xscale_orig); /* free previous argument */
      args_info->xscale_orig = 0;
    }
  if (args_info->yscale_orig)
    {
      free (args_info->yscale_orig); /* free previous argument */
      args_info->yscale_orig = 0;
    }
  if (args_info->zscale_orig)
    {
      free (args_info->zscale_orig); /* free previous argument */
      args_info->zscale_orig = 0;
    }
  
  for (i = 0; i < args_info->inputs_num; ++i)
    free (args_info->inputs [i]);
  
  if (args_info->inputs_num)
    free (args_info->inputs);
  
  clear_given (args_info);
}

int
cmdline_parser_file_save(const char *filename, struct gengetopt_args_info *args_info)
{
  FILE *outfile;
  int i = 0;

  outfile = fopen(filename, "w");

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot open file for writing: %s\n", CMDLINE_PARSER_PACKAGE, filename);
      return EXIT_FAILURE;
    }

  if (args_info->help_given) {
    fprintf(outfile, "%s\n", "help");
  }
  if (args_info->version_given) {
    fprintf(outfile, "%s\n", "version");
  }
  if (args_info->verbosity_given) {
    if (args_info->verbosity_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "verbosity", args_info->verbosity_orig);
    } else {
      fprintf(outfile, "%s\n", "verbosity");
    }
  }
  if (args_info->out_given) {
    if (args_info->out_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "out", args_info->out_orig);
    } else {
      fprintf(outfile, "%s\n", "out");
    }
  }
  if (args_info->pack_given) {
    if (args_info->pack_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "pack", args_info->pack_orig);
    } else {
      fprintf(outfile, "%s\n", "pack");
    }
  }
  if (args_info->bpv_given) {
    if (args_info->bpv_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "bpv", args_info->bpv_orig);
    } else {
      fprintf(outfile, "%s\n", "bpv");
    }
  }
  if (args_info->xscale_given) {
    if (args_info->xscale_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "xscale", args_info->xscale_orig);
    } else {
      fprintf(outfile, "%s\n", "xscale");
    }
  }
  if (args_info->yscale_given) {
    if (args_info->yscale_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "yscale", args_info->yscale_orig);
    } else {
      fprintf(outfile, "%s\n", "yscale");
    }
  }
  if (args_info->zscale_given) {
    if (args_info->zscale_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "zscale", args_info->zscale_orig);
    } else {
      fprintf(outfile, "%s\n", "zscale");
    }
  }
  
  fclose (outfile);

  i = EXIT_SUCCESS;
  return i;
}

void
cmdline_parser_free (struct gengetopt_args_info *args_info)
{
  cmdline_parser_release (args_info);
}


/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  return cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  int result;

  result = cmdline_parser_internal (argc, argv, args_info, override, initialize, check_required, NULL);

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_required (struct gengetopt_args_info *args_info, const char *prog_name)
{
  int result = EXIT_SUCCESS;

  if (cmdline_parser_required2(args_info, prog_name, NULL) > 0)
    result = EXIT_FAILURE;

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_required2 (struct gengetopt_args_info *args_info, const char *prog_name, const char *additional_error)
{
  int error = 0;

  if (! args_info->out_given)
    {
      fprintf (stderr, "%s: '--out' ('-o') option required%s\n", prog_name, (additional_error ? additional_error : ""));
      error = 1;
    }

  return error;
}

int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */

  int error = 0;
  struct gengetopt_args_info local_args_info;

  if (initialize)
    cmdline_parser_init (args_info);

  cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "verbosity",	1, NULL, 'v' },
        { "out",	1, NULL, 'o' },
        { "pack",	1, NULL, 'p' },
        { "bpv",	1, NULL, 'b' },
        { "xscale",	1, NULL, 'j' },
        { "yscale",	1, NULL, 'k' },
        { "zscale",	1, NULL, 'l' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVv:o:p:b:j:k:l:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          cmdline_parser_print_help ();
          cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          cmdline_parser_print_version ();
          cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'v':	/* Set the verbosity level (0=quiet 10=verbose 20=bombastic).  */
          if (local_args_info.verbosity_given)
            {
              fprintf (stderr, "%s: `--verbosity' (`-v') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->verbosity_given && ! override)
            continue;
          local_args_info.verbosity_given = 1;
          args_info->verbosity_given = 1;
          args_info->verbosity_arg = strtol (optarg, &stop_char, 0);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->verbosity_orig)
            free (args_info->verbosity_orig); /* free previous string */
          args_info->verbosity_orig = gengetopt_strdup (optarg);
          break;

        case 'o':	/* Output file name.  */
          if (local_args_info.out_given)
            {
              fprintf (stderr, "%s: `--out' (`-o') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->out_given && ! override)
            continue;
          local_args_info.out_given = 1;
          args_info->out_given = 1;
          if (args_info->out_arg)
            free (args_info->out_arg); /* free previous string */
          args_info->out_arg = gengetopt_strdup (optarg);
          if (args_info->out_orig)
            free (args_info->out_orig); /* free previous string */
          args_info->out_orig = gengetopt_strdup (optarg);
          break;

        case 'p':	/* How to scale/fit counts into voxels.\n 0=PACK_SCALE, 1=PACK_CLIP, 2=PACK_WRAP.  */
          if (local_args_info.pack_given)
            {
              fprintf (stderr, "%s: `--pack' (`-p') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->pack_given && ! override)
            continue;
          local_args_info.pack_given = 1;
          args_info->pack_given = 1;
          args_info->pack_arg = strtol (optarg, &stop_char, 0);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->pack_orig)
            free (args_info->pack_orig); /* free previous string */
          args_info->pack_orig = gengetopt_strdup (optarg);
          break;

        case 'b':	/* Bits per voxel.  This is an unsigned data type.\nCan be 8, 16, or 32..  */
          if (local_args_info.bpv_given)
            {
              fprintf (stderr, "%s: `--bpv' (`-b') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->bpv_given && ! override)
            continue;
          local_args_info.bpv_given = 1;
          args_info->bpv_given = 1;
          args_info->bpv_arg = strtol (optarg, &stop_char, 0);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->bpv_orig)
            free (args_info->bpv_orig); /* free previous string */
          args_info->bpv_orig = gengetopt_strdup (optarg);
          break;

        case 'j':	/* Scale the voxels..  */
          if (local_args_info.xscale_given)
            {
              fprintf (stderr, "%s: `--xscale' (`-j') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->xscale_given && ! override)
            continue;
          local_args_info.xscale_given = 1;
          args_info->xscale_given = 1;
          args_info->xscale_arg = (float)strtod (optarg, &stop_char);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->xscale_orig)
            free (args_info->xscale_orig); /* free previous string */
          args_info->xscale_orig = gengetopt_strdup (optarg);
          break;

        case 'k':	/* Scale the voxels..  */
          if (local_args_info.yscale_given)
            {
              fprintf (stderr, "%s: `--yscale' (`-k') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->yscale_given && ! override)
            continue;
          local_args_info.yscale_given = 1;
          args_info->yscale_given = 1;
          args_info->yscale_arg = (float)strtod (optarg, &stop_char);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->yscale_orig)
            free (args_info->yscale_orig); /* free previous string */
          args_info->yscale_orig = gengetopt_strdup (optarg);
          break;

        case 'l':	/* Scale the voxels..  */
          if (local_args_info.zscale_given)
            {
              fprintf (stderr, "%s: `--zscale' (`-l') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->zscale_given && ! override)
            continue;
          local_args_info.zscale_given = 1;
          args_info->zscale_given = 1;
          args_info->zscale_arg = (float)strtod (optarg, &stop_char);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->zscale_orig)
            free (args_info->zscale_orig); /* free previous string */
          args_info->zscale_orig = gengetopt_strdup (optarg);
          break;


        case 0:	/* Long option with no short option */
        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */



  if (check_required)
    {
      error += cmdline_parser_required2 (args_info, argv[0], additional_error);
    }

  cmdline_parser_release (&local_args_info);

  if ( error )
    return (EXIT_FAILURE);

  if (optind < argc)
    {
      int i = 0 ;

      args_info->inputs_num = argc - optind ;
      args_info->inputs =
        (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        args_info->inputs[ i++ ] = gengetopt_strdup (argv[optind++]) ;
    }

  return 0;

failure:
  
  cmdline_parser_release (&local_args_info);
  return (EXIT_FAILURE);
}
